unit myUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ShellAPI, StdCtrls;

const
  WM_MYTRAYNOTIFY=WM_USER+1; //wq wm message

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Memo1: TMemo;
    Label1: TLabel;
    Memo2: TMemo;
    Memo3: TMemo;
    Label2: TLabel;
    Label3: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure WndProc(var Msg: TMessage); override;  // tray icon  call back function
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
  blue_nid: TNotifyIconData;
  blue_icon: TIcon;
begin
  blue_icon:= TIcon.Create;
  blue_icon.LoadFromFile('COLOR_BL.ICO');
  blue_nid.cbSize := sizeof(blue_nid);
  blue_nid.Wnd := self.Handle;
  // blueicon ]w 200
  blue_nid.uID := 200;
  blue_nid.uFlags := NIF_MESSAGE or NIF_ICON or NIF_TIP;
  // NIF_MESSAGE ]w message wm_xxx
  // NIF_ICON ]w ICON
  // NIF_TIP ]w ܰT
  blue_nid.hIcon := blue_icon.Handle;
  blue_nid.uCallbackMessage := WM_MYTRAYNOTIFY;
  StrPCopy(blue_nid.szTip, Memo2.Lines.Text);
  Shell_NotifyIcon(NIM_ADD, @blue_nid);
  blue_icon.Free;
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  blue_nid: TNotifyIconData;
begin
  blue_nid.cbSize := sizeof(blue_nid);
  blue_nid.Wnd := self.Handle;
  // blueicon ]w 200
  blue_nid.uID := 200;
  Shell_NotifyIcon(NIM_DELETE, @blue_nid);
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  green_nid: TNotifyIconData;
  green_icon: TIcon;
begin
  green_icon:= TIcon.Create;
  green_icon.LoadFromFile('COLOR_GR.ICO');
  green_nid.cbSize := sizeof(green_nid);
  green_nid.Wnd := self.Handle;
  // greenicon ]w 300
  green_nid.uID := 300;
  green_nid.uFlags := NIF_MESSAGE or NIF_ICON or NIF_TIP;
  green_nid.hIcon := green_icon.Handle;
  green_nid.uCallbackMessage := WM_MYTRAYNOTIFY;
  StrPCopy(green_nid.szTip, Memo3.Lines.Text);
  Shell_NotifyIcon(NIM_ADD, @green_nid);
  green_icon.Free;
end;

procedure TForm1.Button4Click(Sender: TObject);
var
  green_nid: TNotifyIconData;
begin
  green_nid.cbSize := sizeof(green_nid);
  green_nid.Wnd := self.Handle;
  // greenicon ]w 300
  green_nid.uID := 300;
  Shell_NotifyIcon(NIM_DELETE, @green_nid);
end;

procedure TForm1.WndProc(var Msg: TMessage);
var
  pt: TPOINT;
  curpos, curaction, curicon: string;

begin
  if Msg.Msg = WM_MYTRAYNOTIFY then
  begin
    // ICON  uID
    case Msg.WParam of
      200: curicon := 'blue icon mouse action: ';
      300: curicon := 'green icon mouse action: ';
    end;
    GetCursorPos(pt);
    curpos := 'X: '+IntToStr(pt.X)+',  Y: '+IntToStr(pt.Y);
    // ƹʧ@
    case Msg.LParam of
      WM_LBUTTONDOWN:   curaction := 'Left Button Down ';
      WM_RBUTTONDOWN:   curaction := 'Right Button Down ';
      WM_LBUTTONUP:     curaction := 'Left Button Up ';
      WM_RBUTTONUP:     curaction := 'Right Button up ';
      WM_MOUSEMOVE:     curaction := 'Mouse Move ';
      WM_LBUTTONDBLCLK: curaction := 'Left Button DoubleClick ';
      WM_RBUTTONDBLCLK: curaction := 'Right Button DoubleClick ';
    end;
    Memo1.Lines.Add(curicon+' '+curaction+' '+curpos);
  end;
  inherited;  
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var
  nid: TNotifyIconData;
begin
  // b{ɭnOoNҦ icon Rh.
  nid.cbSize := sizeof(nid);
  nid.Wnd := self.Handle;
  nid.uID := 200;
  Shell_NotifyIcon(NIM_DELETE, @nid);
  nid.uID := 300;
  Shell_NotifyIcon(NIM_DELETE, @nid);
end;

end.
